<template>
  <section class="section">
    <div class="container">
      <h1 class="title">Authorise</h1>
      <hr>
      <a
        :href="`https://github.com/login/oauth/authorize?client_id=${clientId}&redirect_uri=${redirectURI}&scope=${scope}&state=${state}`"
        class="button is-info">
        <b-icon
          icon="github"
          pack="fab"
          size="is-small" />
        <span>Authorise</span>
      </a>
    </div>
  </section>
</template>

<script>
import uuidv4 from 'uuid/v4'
import gql from 'graphql-tag'
export default {
  data: () => ({
    clientId: process.env.VUE_APP_GITHUB_CLIENT_ID,
    redirectURI: process.env.VUE_APP_GITHUB_REDIRECT_URI,
    scope: 'admin:repo_hook',
    state: ''
  }),
  created () {
    const state = uuidv4()
    this.state = state
    this.$apollo.mutate({
      mutation: gql`mutation($state: String!) {
        storeState(state: $state) {
          id
        }
      }`,
      variables: { state }
    })
  }
}
</script>
